from functools import wraps
import services
import sims4.resources
from sims4.tuning.instance_manager import InstanceManager
from sims4.resources import Types

def inject(target_function, new_function):
    @wraps(target_function)
    def _inject(*args, **kwargs):
        return new_function(target_function, *args, **kwargs)
    return _inject

def inject_to(target_object, target_function_name):
    def _inject_to(new_function):
        target_function = getattr(target_object, target_function_name)
        setattr(target_object, target_function_name, inject(target_function, new_function))
        return new_function
    return _inject_to

SeSeSimmi_Norbit_163702_SnippetId = 163702
SeSeSimmi_Norbit_163702_MixerId = (3116719507,3652045353,3103508349,2969174536,3665562737,2162147475,2198894013,2376921060,4227200093,2343697497,2412123803,3013181057,4093857134,3401150761,2401152637,2648132197,)
@inject_to(InstanceManager, 'load_data_into_class_instances')
def SeSeSimmi_Norbit_AddMixer_163702(original, self):
    original(self)
    if self.TYPE == Types.SNIPPET:
        key = sims4.resources.get_resource_key(SeSeSimmi_Norbit_163702_SnippetId, Types.SNIPPET)
        snippet_tuning = self._tuned_classes.get(key)
        if snippet_tuning is None:
            return
        for m_id in SeSeSimmi_Norbit_163702_MixerId:
            affordance_manager = services.affordance_manager()
            key = sims4.resources.get_resource_key(m_id, Types.INTERACTION)
            mixer_tuning = affordance_manager.get(key)
            if mixer_tuning is None:
                continue
            if mixer_tuning in snippet_tuning.value:
                continue
            snippet_tuning.value = snippet_tuning.value + (mixer_tuning, )

